summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorMichał Górny <mgorny@gentoo.org>2015-06-04 20:53:17 +0200
committerMichał Górny <mgorny@gentoo.org>2015-06-04 20:53:17 +0200
commitb1864a0bcee613c33566499df688954664c664f0 (patch)
treeb504bc8a92199d26a8ac76d9129bbc026c0aa102 /dev-binpkg
parentdev-python/pypy-binpackage -> dev-binpkg/pypy, for correct ${P} (diff)
downloadmgorny-b1864a0bcee613c33566499df688954664c664f0.tar.gz
mgorny-b1864a0bcee613c33566499df688954664c664f0.tar.bz2
mgorny-b1864a0bcee613c33566499df688954664c664f0.zip
dev-binpkg/pypy: bump to 2.6.0
Diffstat (limited to 'dev-binpkg')
-rw-r--r--dev-binpkg/pypy/Manifest2
-rw-r--r--dev-binpkg/pypy/pypy-2.6.0.ebuild203
2 files changed, 205 insertions, 0 deletions
diff --git a/dev-binpkg/pypy/Manifest b/dev-binpkg/pypy/Manifest
index df7bae3..aac183d 100644
--- a/dev-binpkg/pypy/Manifest
+++ b/dev-binpkg/pypy/Manifest
@@ -1 +1,3 @@
DIST pypy-2.5.1-src.tar.bz2 16740876 SHA256 ddb3a580b1ee99c5a699172d74be91c36dda9a38946d4731d8c6a63120a3ba2a SHA512 ac4cab47566d7d4e1a293a680e0dffa301c99a8329c2e68f645f186c0266cbe8f045a03e392c0cc2112a16178037cd978b7867ad073bf5dd957dd19f4c818067 WHIRLPOOL 6f16c4090780081dfe1d4642186262c66d4ac1a4b3b8311e573bfa6029eb7aac0483b3e48cad5ce03879391a4e316c0186d33fac5e86d0024ff20cc6d4dc0dd3
+DIST pypy-2.6.0-src.tar.bz2 16858400 SHA256 9bf353f22d25e97a85a6d3766619966055edea1ea1b2218445d683a8ad0399d9 SHA512 82a6a44c0c551a1291215394610e5331cf83216b38ac9f1a79a3eab53ba2933b121c3154b58cead814c73a1da1fc95d895324bb0c43e8e0429438b0dea527cc4 WHIRLPOOL e536ff5d3b393c6834fd721f383318b5dcef79046f475b0f1fe737c67c56e8769cabc0a35f553da5dc475a255c5711de01bd6d42e541cabbab3b9e30f20c9a5c
+DIST python-gentoo-patches-2.7.10-0.tar.xz 12892 SHA256 c9a838bd62ae50cc385da23a837acfd05f2b74e4f086c9c76eb4d3aa5366ef6d SHA512 5f100944635e360691dc0a2b340a906646c4ae9ee558246ddffc56e8b15d389f25f1fbdc1db4cc08e7d29560d04d66b058b3904902899d58ecae8c408ebdf056 WHIRLPOOL f69e9a518bb7ee50c1b262a21e70e1e2443f859ee6d2f4fa84421120dbd054a06ce8dd6cfea8512cbc64bce806322b879c25c561d5eb05e1ba6cc15035b373a9
diff --git a/dev-binpkg/pypy/pypy-2.6.0.ebuild b/dev-binpkg/pypy/pypy-2.6.0.ebuild
new file mode 100644
index 0000000..165c443
--- /dev/null
+++ b/dev-binpkg/pypy/pypy-2.6.0.ebuild
@@ -0,0 +1,203 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/dev-python/pypy/pypy-2.6.0.ebuild,v 1.1 2015/06/04 18:46:39 mgorny Exp $
+
+EAPI=5
+
+PYTHON_COMPAT=( python2_7 pypy )
+inherit check-reqs eutils multilib multiprocessing pax-utils python-any-r1 toolchain-funcs versionator
+
+CPY_PATCHSET_VERSION="2.7.10-0"
+
+DESCRIPTION="A fast, compliant alternative implementation of the Python language"
+HOMEPAGE="http://pypy.org/"
+SRC_URI="https://bitbucket.org/pypy/pypy/downloads/${P}-src.tar.bz2
+ http://dev.gentoo.org/~floppym/python/python-gentoo-patches-${CPY_PATCHSET_VERSION}.tar.xz"
+
+LICENSE="MIT"
+SLOT="0/$(get_version_component_range 1-2 ${PV})"
+KEYWORDS="~amd64 ~x86 ~amd64-linux ~x86-linux"
+IUSE="bzip2 +jit low-memory ncurses sandbox shadowstack sqlite cpu_flags_x86_sse2"
+
+DEPEND=">=sys-libs/zlib-1.1.3:0=
+ virtual/libffi:0=
+ virtual/libintl:0=
+ dev-libs/expat:0=
+ dev-libs/openssl:0=[-bindist]
+ bzip2? ( app-arch/bzip2:0= )
+ ncurses? ( sys-libs/ncurses:5= )
+ app-arch/xz-utils
+ ${PYTHON_DEPS}"
+
+S="${WORKDIR}/${P}-src"
+
+pkg_pretend() {
+ if use low-memory; then
+ if ! python_is_installed pypy; then
+ eerror "USE=low-memory requires a (possibly old) version of dev-python/pypy"
+ eerror "or dev-python/pypy-bin being installed. Please install it using e.g.:"
+ eerror
+ eerror " $ emerge -1v dev-python/pypy-bin"
+ eerror
+ eerror "before attempting to build dev-python/pypy[low-memory]."
+ die "dev-python/pypy-bin (or dev-python/pypy) needs to be installed for USE=low-memory"
+ fi
+
+ CHECKREQS_MEMORY="1750M"
+ use amd64 && CHECKREQS_MEMORY="3500M"
+ else
+ CHECKREQS_MEMORY="3G"
+ use amd64 && CHECKREQS_MEMORY="6G"
+ fi
+
+ check-reqs_pkg_pretend
+
+ [[ ${PYPY_BINPKG_STORE} ]] || die 'PYPY_BINPKG_STORE unset, wtf?!'
+}
+
+pkg_setup() {
+ pkg_pretend
+
+ if python_is_installed pypy; then
+ if [[ ! ${EPYTHON} || ${EPYTHON} == pypy ]] || use low-memory; then
+ einfo "Using already-installed PyPy to perform the translation."
+ local EPYTHON=pypy
+ else
+ einfo "Using ${EPYTHON} to perform the translation. Please note that upstream"
+ einfo "recommends using PyPy for that. If you wish to do so, please unset"
+ einfo "the EPYTHON variable."
+ fi
+ fi
+
+ python-any-r1_pkg_setup
+
+ local cpu
+ if use amd64; then
+ # common denominator between Intel & AMD
+ cpu='x86-64'
+ elif use x86; then
+ if use cpu_flags_x86_sse2; then
+ # lowest with SSE2
+ cpu='pentium-m'
+ else
+ # lowest with SSE, compat. with athlon-xp
+ # TODO: do we want to support something older?
+ cpu='pentium3'
+ fi
+ else
+ die "Unsupported arch ${ARCH}"
+ fi
+
+ export CFLAGS="-march=${cpu} -mtune=generic -O2 -pipe"
+ export CXXFLAGS=${CFLAGS}
+
+ elog "CFLAGS: ${CFLAGS}"
+}
+
+src_prepare() {
+ epatch "${FILESDIR}/1.9-scripts-location.patch" \
+ "${FILESDIR}/1.9-distutils.unixccompiler.UnixCCompiler.runtime_library_dir_option.patch" \
+ "${FILESDIR}"/2.5.0-shared-lib.patch # 517002
+
+ # apply CPython stdlib patches
+ pushd lib-python/2.7 > /dev/null || die
+ epatch "${FILESDIR}"/2.5.0_all_distutils_cxx.patch \
+ "${WORKDIR}"/patches/22_all_turkish_locale.patch \
+ "${WORKDIR}"/patches/62_all_xml.use_pyxml.patch
+ popd > /dev/null || die
+
+ epatch_user
+}
+
+src_compile() {
+ tc-export CC
+
+ local jit_backend
+ if use jit; then
+ jit_backend='--jit-backend='
+
+ # We only need the explicit sse2 switch for x86.
+ # On other arches we can rely on autodetection which uses
+ # compiler macros. Plus, --jit-backend= doesn't accept all
+ # the modern values...
+
+ if use x86; then
+ if use cpu_flags_x86_sse2; then
+ jit_backend+=x86
+ else
+ jit_backend+=x86-without-sse2
+ fi
+ else
+ jit_backend+=auto
+ fi
+ fi
+
+ local args=(
+ --shared
+ $(usex jit -Ojit -O2)
+ $(usex shadowstack --gcrootfinder=shadowstack '')
+ $(usex sandbox --sandbox '')
+
+ ${jit_backend}
+ --make-jobs=$(makeopts_jobs)
+
+ pypy/goal/targetpypystandalone
+ )
+
+ # Avoid linking against libraries disabled by use flags
+ local opts=(
+ bzip2:bz2
+ ncurses:_minimal_curses
+ )
+
+ local opt
+ for opt in "${opts[@]}"; do
+ local flag=${opt%:*}
+ local mod=${opt#*:}
+
+ args+=(
+ $(usex ${flag} --withmod --withoutmod)-${mod}
+ )
+ done
+
+ local interp=( "${PYTHON}" )
+ if use low-memory; then
+ interp=( env PYPY_GC_MAX_DELTA=200MB
+ "${PYTHON}" --jit loop_longevity=300 )
+ fi
+
+ set -- "${interp[@]}" rpython/bin/rpython --batch "${args[@]}"
+ echo -e "\033[1m${@}\033[0m"
+ "${@}" || die "compile error"
+
+ pax-mark m "${ED%/}${INSDESTTREE}/pypy-c"
+}
+
+src_install() {
+ local flags=( bzip2 jit ncurses sandbox shadowstack )
+ use x86 && flags+=( cpu_flags_x86_sse2 )
+ local f suffix="-${ARCH}"
+
+ for f in ${flags[@]}; do
+ use ${f} && suffix+="+${f#cpu_flags_x86_}"
+ done
+
+ local BIN_P=pypy-bin-${PV}
+
+ einfo "Zipping PyPy ..."
+ mkdir "${BIN_P}${suffix}"{,/include} || die
+ mv pypy-c libpypy-c.so "${BIN_P}${suffix}"/ || die
+ mv include/pypy_* "${BIN_P}${suffix}"/include/ || die
+ chmod +x "${BIN_P}${suffix}"/pypy-c || die
+
+ tar -cf "${BIN_P}${suffix}.tar" "${BIN_P}${suffix}" || die
+ xz -vz9e "${BIN_P}${suffix}.tar" || die
+}
+
+# Yup, very hacky.
+pkg_preinst() {
+ # integrity check.
+ [[ ${PYPY_BINPKG_STORE} ]] || die 'PYPY_BINPKG_STORE unset, wtf?!'
+ mkdir -p "${ROOT%/}${PYPY_BINPKG_STORE}" || die
+ mv "${S}"/*.tar.xz "${ROOT%/}${PYPY_BINPKG_STORE}" || die
+}